package org.warp.jcwdb;

import java.util.Iterator;
import java.util.List;
import java.util.function.Consumer;

public interface LightList<T> extends List<T> {

	Iterator<EntryReference<T>> iteratorReferences();

	void forEachReference(Consumer<? super EntryReference<T>> action);

	EntryReference<T> addEntry(T o);

	boolean remove(EntryReference<T> ref);

	EntryReference<T> getReference(int index);

	int indexOfEntry(EntryReference<T> ref);

	int lastIndexOfEntry(EntryReference<T> ref);

	void appendIndex(long elementIndex);
}
